/* Server Banca (versione 2)*/

#include <stdio.h>
#include<signal.h>
#include<errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 100
#define PERMS 0777
#define max(a,b) ((a) > (b) ? (a) : (b))

/****************************************************************/
typedef struct {
	char* ec;
	int deposito;
} Conto;

Conto conti[] = {
	"ec0.txt", 1000,
	"ec1.txt", 1000,
	"ec2.txt", 1000,
	"ec3.txt", 1000,
	"ec4.txt", 1000,
	"ec5.txt", 1000,
};

typedef struct {
	int numcc;
	int impOp;
	char tipoOp;
} Request;

Request* req;


/****************************************************************/
void gestore(int signo)
{
 int stato;
 printf("esecuzione gestore di SIGCHLD\n");
 wait(&stato);
}


/*****************************************************************/

main(int argc, char **argv)
{
int  listenfd, connfd, udpfd, fd_mov, fd_ec, nready, maxfdp1;
char buffTCP[DIM_BUFF];
char *simp, *ris, zero=0;
char movimento[30];
fd_set rset;
int len, nread, nwrite, i, n, numcc, num, imp;
const int on = 1;
struct sockaddr_in cliaddr, servaddr;

req=(Request*)malloc(sizeof(Request));
ris=(char*)malloc(30);



/* CREAZIONE SOCKET TCP PER RICHIESTE DI ESTRATTO CONTO ---------------------- */
listenfd=socket(AF_INET, SOCK_STREAM, 0); 
if(listenfd <0) 
	{perror("apertura socket TCP "); exit(1);}
printf("Server: creata la socket TCP d'ascolto per le richieste di estratto conto, fd=%d\n", listenfd);

/* INIZIALIZZAZIONE INDIRIZZO SERVER ----------------------------------------- */
memset ((char *)&servaddr, 0, sizeof(servaddr));
servaddr.sin_family = AF_INET;
servaddr.sin_addr.s_addr = htonl(INADDR_ANY); 
servaddr.sin_port = htons(12345);

if(setsockopt(listenfd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
	{perror("set opzioni socket TCP"); exit(1);}
printf("Server: set opzioni socket TCP ok\n");

if(bind(listenfd,(struct sockaddr *) &servaddr, sizeof(servaddr))<0) 
	{perror("bind socket TCP"); exit(1);}
printf("Server: bind socket TCP ok\n");

if (listen(listenfd, 5)<0)
	{perror("listen"); exit(1);}
printf("Server: listen ok\n");



/* CREAZIONE SOCKET UDP PER RICHIESTE DI MOVIMENTI ---------------------------- */
udpfd=socket(AF_INET, SOCK_DGRAM, 0);
if(udpfd <0) 
	{perror("apertura socket UDP"); exit(1);}
printf("Server: creata la socket UDP per le richieste di movimenti, fd=%d\n", udpfd);

/* INIZIALIZZAZIONE INDIRIZZO SERVER ------------------------------------------ */
memset ((char *)&servaddr, 0, sizeof(servaddr));
servaddr.sin_family = AF_INET;
servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
servaddr.sin_port = htons(12346);

if(setsockopt(udpfd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
	{perror("set opzioni socket UDP"); exit(1);}
printf("Server: set opzioni socket UDP ok\n");

if(bind(udpfd,(struct sockaddr *) &servaddr, sizeof(servaddr))<0) 
	{perror("bind socket UDP"); exit(1);}
printf("Server: bind socket UDP ok\n");



/* AGGANCIO GESTORE PER EVITARE FIGLI ZOMBIE ---------------------------------- */

sigset(SIGCHLD, gestore);



/* PULIZIA E SETTAGGIO MASCHERA DEI FILE DESCRIPTOR --------------------------- */

FD_ZERO(&rset);
maxfdp1=max(listenfd, udpfd)+1; 


/* CICLO DI RICEZIONE EVENTI DALLA SELECT ------------------------------------- */
for(;;)
{
 FD_SET(listenfd, &rset);
 FD_SET(udpfd, &rset);

 if ((nready=select(maxfdp1, &rset, NULL, NULL, NULL))<0)
 {
  if (errno==EINTR) continue;
  else {perror("select"); exit(1);}
 }



/* GESTIONE RICHIESTE DI ESTRATTO CONTO --------------------------------------- */ 

if (FD_ISSET(listenfd, &rset))
{ 
 printf("Server: ricevuta richiesta di estratto conto\n"); 
 len = sizeof(cliaddr);

 if((connfd = accept(listenfd,(struct sockaddr *)&cliaddr,&len))<0) 
 {
   if (errno==EINTR) continue;	
   else {perror("accept"); exit(1);}
 }
 
 if (fork()==0)
 { /* processo figlio che serve la richiesta di operazione */
   close(listenfd);
   printf("Dentro il figlio...\n"); 
  
   /* non c' pi il ciclo perch viene creato un nuovo figlio */
   /* per ogni richiesta di EC */
  
  
  	i=read(connfd, &n, sizeof(int));

  	if (i<0) { perror("read"); exit(2);}
  	if (i==0) break;

  	numcc=ntohl(n);
  	printf("Richiesto conto N. %i\n", numcc); 

  	if ((numcc<0) || (numcc>5)) 
		{printf("Numero conto inesistente\n"); write(connfd, "N", 1);} 
  	else {
  		fd_ec=open(conti[numcc].ec, O_RDONLY); 
  		if(fd_ec<0) 
			{printf("File inesistente\n"); write(connfd, "B", 1);}
      	else {
			write(connfd, "S", 1); 

			/* lettura dal file (a blocchi, non a linee) e scrittura sulla socket */
  			while((nread=read(fd_ec, buffTCP, DIM_BUFF))>0){  
				if (nwrite=write(connfd, buffTCP, nread)<0) 
	     				{perror("write"); exit(4);}
  			}
  			printf("Terminato invio file EC\n");
			close(fd_ec);
		}//else
	}//else
    
    
    close(connfd);	
    exit(0);
	
 }
/* padre chiude la socket dell'operazione */
 close(connfd);

} /* fine gestione richieste di EC */



/* GESTIONE RICHIESTE DI MOVIMENTO ------------------------------------------- */ 

if (FD_ISSET(udpfd, &rset))
{ 
 
 printf("Server: ricevuta richiesta di movimento\n");
 len=sizeof(struct sockaddr_in);

 strcpy(ris, "OK");

 if (recvfrom(udpfd, req, sizeof(Request), 0, (struct sockaddr *)&cliaddr, &len)<0)
  {perror("recvfrom"); exit(1);}

 /* trattiamo le conversioni possibili */
 num=ntohl(req->numcc);
 imp=ntohl(req->impOp);

 printf("Movimento richiesto: %c di %i  su cc n. %i\n", req->tipoOp, imp, num);

/* APERTURA O CREAZIONE DEL FILE ESTRATTO CONTO ----------------------------- */
 if((fd_mov=open(conti[num].ec, O_WRONLY|O_CREAT|O_APPEND, PERMS))<0)
	{ perror("open"); exit(1);}

  
/* RICHIESTA DI VERSAMENTO -------------------------------------------------- */
 if(req->tipoOp=='V')
 {
  printf("versamento...\n");
  conti[num].deposito=+imp;
  strcpy(movimento,"versamento di ");
  write(fd_mov, movimento, strlen(movimento));
  sprintf(simp, "%i\n", imp);
  write(fd_mov, simp, strlen(simp));
 }


/* RICHIESTA DI PRELIEVO ----------------------------------------------------- */
 if(req->tipoOp=='P')
 { 
  printf("prelievo...\n");
  if ( (conti[num].deposito-imp) <0)
    {strcpy(ris, "errore: prelievo superiore al deposito\n");}
  conti[num].deposito=-imp;
  strcpy(movimento,"prelievo di ");
  write(fd_mov, movimento, strlen(movimento));
  sprintf(simp, "%i\n", imp);
  write(fd_mov, simp, strlen(simp));
 }

 i=sendto(udpfd, ris, strlen(ris)+1, 0, (struct sockaddr *)&cliaddr, len);
 
  if (i<0)
	{perror("sendto"); exit(1);}
  
} /* if UDP */

} /* ciclo for della select */

}

